# Generated by Django 2.0.6 on 2020-10-27 10:13

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Extract',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
                ('etype', models.CharField(choices=[('pcrpos', 'PCRPos'), ('sample', 'sample'), ('extneg', 'negative extraction')], max_length=7)),
            ],
        ),
        migrations.CreateModel(
            name='Extract_qualifier',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('key', models.CharField(max_length=255)),
                ('value', models.CharField(max_length=255)),
                ('extract', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Extract')),
            ],
        ),
        migrations.CreateModel(
            name='Library',
            fields=[
                ('name', models.CharField(max_length=255, primary_key=True, serialize=False)),
            ],
        ),
        migrations.CreateModel(
            name='PCR',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('run', models.IntegerField()),
                ('run_position', models.IntegerField(blank=True, null=True)),
                ('cycles', models.IntegerField()),
                ('denaturation_time', models.IntegerField()),
                ('hybridation_time', models.IntegerField()),
                ('synthesis_time', models.IntegerField()),
                ('final_synthesis_time', models.IntegerField()),
                ('denaturation_temperature', models.IntegerField()),
                ('hybridation_temperature', models.IntegerField()),
                ('synthesis_temperature', models.IntegerField()),
                ('final_synthesis_temperature', models.IntegerField()),
                ('machine_id', models.CharField(blank=True, max_length=255, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Plate_96',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=250)),
            ],
        ),
        migrations.CreateModel(
            name='PrimerPair',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('forward_sequence', models.CharField(max_length=255)),
                ('reverse_sequence', models.CharField(max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255, unique=True)),
                ('available', models.BooleanField(default=True)),
                ('description', models.TextField(max_length=1000)),
                ('email', models.EmailField(max_length=255)),
                ('leader', models.CharField(max_length=255)),
                ('parentProject', models.ManyToManyField(blank=True, default=None, to='metabaseEditor.Project')),
                ('users', models.ManyToManyField(blank=True, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='Sample',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='Sample_qualifier',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('key', models.CharField(max_length=255)),
                ('value', models.CharField(max_length=255)),
                ('sample', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='sample_qualifiers', to='metabaseEditor.Sample')),
            ],
        ),
        migrations.CreateModel(
            name='Sequencing_file',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('file_name', models.CharField(max_length=255)),
                ('file_type', models.CharField(max_length=255)),
                ('sequencingTechnology', models.CharField(max_length=255)),
                ('sequencingInstrument', models.CharField(max_length=255)),
            ],
        ),
        migrations.CreateModel(
            name='Sequencing_information',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('info_file', models.BinaryField()),
                ('file_name', models.CharField(max_length=255)),
                ('file_type', models.CharField(max_length=255)),
                ('provider', models.CharField(max_length=255)),
                ('contact', models.CharField(max_length=255)),
                ('sequencing_date', models.DateTimeField()),
            ],
        ),
        migrations.CreateModel(
            name='Submission_file',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('file_name', models.CharField(max_length=255)),
                ('submission_date', models.DateTimeField(auto_now=True)),
                ('excel_file', models.BinaryField()),
            ],
        ),
        migrations.CreateModel(
            name='Tube_mix',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=255)),
                ('mtype', models.CharField(max_length=255)),
                ('quantity', models.IntegerField(default=0)),
                ('concentration', models.IntegerField(default=0)),
                ('project', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Project')),
                ('submission_file', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Submission_file')),
            ],
        ),
        migrations.CreateModel(
            name='Unused_extract',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('extract', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Extract')),
                ('submission_file', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Submission_file')),
            ],
        ),
        migrations.CreateModel(
            name='Unused_sample',
            fields=[
                ('id', models.AutoField(primary_key=True, serialize=False)),
                ('sample', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Sample')),
                ('submission_file', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Submission_file')),
            ],
        ),
        migrations.CreateModel(
            name='Well',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('column', models.IntegerField()),
                ('row', models.CharField(max_length=1)),
                ('barcode_forward', models.CharField(max_length=255)),
                ('barcode_reverse', models.CharField(max_length=255)),
                ('wtype', models.CharField(choices=[('pcrneq', 'PCRNeg'), ('blank', 'blank'), ('extract', 'extract')], max_length=7)),
                ('dilution', models.FloatField(default=1)),
                ('extract', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Extract')),
                ('plate', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Plate_96')),
                ('primer', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.PrimerPair')),
            ],
        ),
        migrations.AddField(
            model_name='sequencing_file',
            name='information',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Sequencing_information'),
        ),
        migrations.AddField(
            model_name='sequencing_file',
            name='library_name',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Library'),
        ),
        migrations.AlterUniqueTogether(
            name='primerpair',
            unique_together={('forward_sequence', 'reverse_sequence')},
        ),
        migrations.AddField(
            model_name='pcr',
            name='plate',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Plate_96'),
        ),
        migrations.AddField(
            model_name='pcr',
            name='tube',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Tube_mix'),
        ),
        migrations.AddField(
            model_name='library',
            name='tube',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='libraries', to='metabaseEditor.Tube_mix'),
        ),
        migrations.AddField(
            model_name='extract',
            name='sample',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='metabaseEditor.Sample'),
        ),
        migrations.AlterUniqueTogether(
            name='well',
            unique_together={('plate', 'primer', 'barcode_forward', 'barcode_reverse')},
        ),
        migrations.AlterUniqueTogether(
            name='unused_sample',
            unique_together={('sample', 'submission_file')},
        ),
        migrations.AlterUniqueTogether(
            name='unused_extract',
            unique_together={('extract', 'submission_file')},
        ),
        migrations.AlterUniqueTogether(
            name='sample_qualifier',
            unique_together={('key', 'value', 'sample')},
        ),
        migrations.AlterUniqueTogether(
            name='extract_qualifier',
            unique_together={('key', 'value', 'extract')},
        ),
    ]
